"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var apollo_boost_1 = require("apollo-boost");
require("cross-fetch/polyfill");
var constants_1 = require("./constants");
var TRAILING_SLASHES_REGEX = /\/+$/;
var HttpEventClient = (function () {
    function HttpEventClient(url) {
        if (url === void 0) { url = "https://api.thegraph.com/subgraphs/name/michaelhly/zero_ex_events"; }
        this._client = new apollo_boost_1.ApolloClient({
            cache: new apollo_boost_1.InMemoryCache(),
            link: new apollo_boost_1.HttpLink({
                uri: url.replace(TRAILING_SLASHES_REGEX, "")
            })
        });
    }
    HttpEventClient.prototype.getFillEventsAsync = function (numEntries, requestOpts, numSkip) {
        return __awaiter(this, void 0, void 0, function () {
            var result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, this._client.query({
                            variables: {
                                first: numEntries > constants_1.MAX_PER_PAGE ? constants_1.MAX_PER_PAGE : numEntries,
                                skip: numSkip,
                                where: requestOpts
                            },
                            query: apollo_boost_1.gql(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n        query filledOrders(\n          $first: Int!\n          $where: FilledOrder_filter\n          $skip: Int\n        ) {\n          fillEvents: filledOrders(first: $first, skip: $skip, where: $where) {\n            id\n            maker\n            taker\n            feeRecipient\n            makerFeePaid\n            takerFeePaid\n            makerAssetFilledAmount\n            takerAssetFilledAmount\n            makerAssetDataV2\n            takerAssetDataV2\n            senderV2\n          }\n        }\n      "], ["\n        query filledOrders(\n          $first: Int!\n          $where: FilledOrder_filter\n          $skip: Int\n        ) {\n          fillEvents: filledOrders(first: $first, skip: $skip, where: $where) {\n            id\n            maker\n            taker\n            feeRecipient\n            makerFeePaid\n            takerFeePaid\n            makerAssetFilledAmount\n            takerAssetFilledAmount\n            makerAssetDataV2\n            takerAssetDataV2\n            senderV2\n          }\n        }\n      "])))
                        })];
                    case 1:
                        result = _a.sent();
                        result.totalEntries = result.data.fillEvents.length;
                        return [2, result];
                }
            });
        });
    };
    HttpEventClient.prototype.getCancelEventsAsync = function (numEntries, requestOpts, numSkip) {
        return __awaiter(this, void 0, void 0, function () {
            var result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, this._client.query({
                            variables: {
                                first: numEntries > constants_1.MAX_PER_PAGE ? constants_1.MAX_PER_PAGE : numEntries,
                                where: requestOpts,
                                skip: numSkip
                            },
                            query: apollo_boost_1.gql(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n        query cancelledOrders(\n          $first: Int!\n          $skip: Int\n          $where: CancelledOrder_filter\n        ) {\n          cancelEvents: cancelledOrders(\n            first: $first\n            skip: $skip\n            where: $where\n          ) {\n            id\n            maker\n            feeRecipient\n            makerAssetDataV2\n            takerAssetDataV2\n            senderV2\n          }\n        }\n      "], ["\n        query cancelledOrders(\n          $first: Int!\n          $skip: Int\n          $where: CancelledOrder_filter\n        ) {\n          cancelEvents: cancelledOrders(\n            first: $first\n            skip: $skip\n            where: $where\n          ) {\n            id\n            maker\n            feeRecipient\n            makerAssetDataV2\n            takerAssetDataV2\n            senderV2\n          }\n        }\n      "])))
                        })];
                    case 1:
                        result = _a.sent();
                        result.totalEntries = result.data.cancelEvents.length;
                        return [2, result];
                }
            });
        });
    };
    HttpEventClient.prototype.getEventsByUsersAsync = function (numEntries, numSkip) {
        return __awaiter(this, void 0, void 0, function () {
            var result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, this._client.query({
                            variables: {
                                first: numEntries > constants_1.MAX_PER_PAGE ? constants_1.MAX_PER_PAGE : numEntries,
                                skip: numSkip
                            },
                            query: apollo_boost_1.gql(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n        query users($first: Int!, $skip: Int!) {\n          users(first: $first, skip: $skip) {\n            id\n            filledOrdersMaker {\n              id\n            }\n            filledOrdersTaker {\n              id\n            }\n            filledOrdersFeeRecipient {\n              id\n            }\n          }\n        }\n      "], ["\n        query users($first: Int!, $skip: Int!) {\n          users(first: $first, skip: $skip) {\n            id\n            filledOrdersMaker {\n              id\n            }\n            filledOrdersTaker {\n              id\n            }\n            filledOrdersFeeRecipient {\n              id\n            }\n          }\n        }\n      "])))
                        })];
                    case 1:
                        result = _a.sent();
                        return [2, result];
                }
            });
        });
    };
    return HttpEventClient;
}());
exports.HttpEventClient = HttpEventClient;
var templateObject_1, templateObject_2, templateObject_3;
